##CartaPerigo_v3c=name
##Pasta_de_destino=string  
##Area_estudo=vector polygon
##Areas_ardidas=vector polygon
##Campo_ano=field Areas_ardidas
##MDT=raster
##COS=vector polygon
##Campo_COS=field COS
##Tamanho_do_pixel=number 10

from qgis.core import *
from qgis.utils import *
from PyQt4.QtGui import *
from PyQt4.QtCore import QVariant
import os
from os import path
import processing
import numpy as np
from osgeo import gdal, gdal_array, osr
from PyQt4 import QtGui, QtCore
from qgis.PyQt.QtCore import QPointF,QRectF,QSize

# ******************************************************** Despitar erros **************************************************************
progress.setText("A verificar se caminho para a Pasta de Destino foi correctamente escrito...")

# Colocar janela principal no canto superior esquerdo para deixar a janela do script sempre visivel
Largura=iface.mainWindow().width()
Altura=iface.mainWindow().height()
iface.mainWindow().resize(QSize(100, 100))
canvas = iface.mapCanvas()
canvasCRS = canvas.mapRenderer().destinationCrs().authid()

# Verificar se existem layers com nomes que podem provocar conflitos
while len(QgsMapLayerRegistry.instance().mapLayersByName('Perigosidade')) > 0:
    layer1 = QgsMapLayerRegistry.instance().mapLayersByName('Perigosidade')[0]
    QgsMapLayerRegistry.instance().removeMapLayer(layer1.id())

while len(QgsMapLayerRegistry.instance().mapLayersByName('PerigosidadeNQ')) > 0:
    layer2 = QgsMapLayerRegistry.instance().mapLayersByName('PerigosidadeNQ')[0]
    QgsMapLayerRegistry.instance().removeMapLayer(layer2.id())

while len(QgsMapLayerRegistry.instance().mapLayersByName('Susceptibilidade')) > 0:
    layer3 = QgsMapLayerRegistry.instance().mapLayersByName('Susceptibilidade')[0]
    QgsMapLayerRegistry.instance().removeMapLayer(layer3.id())
    
while len(QgsMapLayerRegistry.instance().mapLayersByName('Probabilidade')) > 0:
    layer4 = QgsMapLayerRegistry.instance().mapLayersByName('Probabilidade')[0]
    QgsMapLayerRegistry.instance().removeMapLayer(layer4.id())

while len(QgsMapLayerRegistry.instance().mapLayersByName('Diff')) > 0:
    layer5 = QgsMapLayerRegistry.instance().mapLayersByName('Diff')[0]
    QgsMapLayerRegistry.instance().removeMapLayer(layer5.id())
    
while len(QgsMapLayerRegistry.instance().mapLayersByName('Autointersect')) > 0:
    layer6 = QgsMapLayerRegistry.instance().mapLayersByName('Autointersect')[0]
    QgsMapLayerRegistry.instance().removeMapLayer(layer6.id())
    
while len(QgsMapLayerRegistry.instance().mapLayersByName('AAClipped')) > 0:
    layer7 = QgsMapLayerRegistry.instance().mapLayersByName('AAClipped')[0]
    QgsMapLayerRegistry.instance().removeMapLayer(layer7.id())
    
while len(QgsMapLayerRegistry.instance().mapLayersByName('Recorrencia')) > 0:
    layer8 = QgsMapLayerRegistry.instance().mapLayersByName('Recorrencia')[0]
    QgsMapLayerRegistry.instance().removeMapLayer(layer8.id())

while len(QgsMapLayerRegistry.instance().mapLayersByName('ProbabilidadeVector')) > 0:
    layer9 = QgsMapLayerRegistry.instance().mapLayersByName('ProbabilidadeVector')[0]
    QgsMapLayerRegistry.instance().removeMapLayer(layer9.id())

lyr1 = processing.getObject(Area_estudo)
lyr1CRS = lyr1.crs().authid()
lyr2 = processing.getObject(Areas_ardidas)
lyr2CRS = lyr2.crs().authid()
fields2 = lyr2.pendingFields()
lyr3 = processing.getObject(COS)
lyr3CRS = lyr3.crs().authid()
fields3 = lyr3.pendingFields()
rst1 = processing.getObject(MDT)
rst1CRS = rst1.crs().authid()

for i in range(fields3.count()):
    field3 = fields3[i]
    if  field3.name()==(Campo_COS) :
        fieldtype_COS=field3.typeName()

for field2 in fields2:
    if field2.name()==str(Campo_ano):
        fieldtype_Ano=field2.typeName()

feat_value=[]
feat_value.append('0')
for feature in lyr2.getFeatures():
    idx2 = lyr2.fieldNameIndex(Campo_ano)
    if str((feature.attributes()[idx2]))=='0' or  str((feature.attributes()[idx2]))=="NULL":
        feat_value.append('1')
#
str_value=[]
str_value.append('0')
for feature in lyr3.getFeatures():
    idx3 = lyr3.fieldNameIndex(Campo_COS)
    if not str((feature.attributes()[idx3])).isdigit():
        str_value.append('1')
    if str((feature.attributes()[idx3]))=='0':
        str_value.append('1')

theselections=[]
lyr1.removeSelection()
lyr2.removeSelection()
lyr3.removeSelection()
for f in lyr2.getFeatures():
    for g in lyr1.getFeatures():
        if g.geometry().intersects(f.geometry()):
            intersection = g.geometry().intersection(f.geometry())
            theselections.append( f.id() )
            break
    if len(theselections) > 0:
        break

if str(Pasta_de_destino)=="":
    QMessageBox.information(None, "Erro na escolha da pasta de destino", "Precisa escolher uma pasta de destino para os ficheiros intermedios e finais. A terminar script...")
    iface.mainWindow().resize(QSize(Largura, Altura))

elif not lyr1CRS==lyr2CRS==lyr3CRS==rst1CRS==canvasCRS:
    QMessageBox.information(None, "Erro", "As layers de Area de Estudo, de Areas Ardidas, da COS, do MDT e da Tela do Mapa (Map Canvas) nao possuem todas o mesmo sistema de coordenadas. A terminar script...")
    iface.mainWindow().resize(QSize(Largura, Altura))
 

elif  Campo_ano<>('Ano')  and Campo_ano<>('ANO')  and Campo_ano<>('ano'):
    QMessageBox.information(None, "Erro", "O nome do campo do ano de incendio escolhido na layer de Areas Ardidas diferente de 'Ano', 'ANO' ou 'ano'. A terminar script...")
    iface.mainWindow().resize(QSize(Largura, Altura))

elif  str(fieldtype_Ano) == 'String':
    QMessageBox.information(None, "Erro", "Campo do Ano na layer de Areas Ardidas do tipo STRING (TEXTO). Este campo necessita ser do tipo INTEGER ou REAL. A terminar script...")
    iface.mainWindow().resize(QSize(Largura, Altura))

elif str(fieldtype_Ano) == 'Date':
    QMessageBox.information(None, "Erro", "Campo do Ano na layer de Areas Ardidas do tipo DATE (DATA). Este campo necessita ser do tipo INTEGER ou REAL. A terminar script...")
    iface.mainWindow().resize(QSize(Largura, Altura))

elif max(feat_value)=='1':
    QMessageBox.information(None, "Erro", "Campo do Ano na layer de Areas Ardidas com valores nulos (0 ou NULL). Preencha todos os valores do Campo do Ano com o ano do incendio do respectivo poligono. A terminar script...")
    iface.mainWindow().resize(QSize(Largura, Altura))
    
elif  str(fieldtype_COS) <> 'String':
    QMessageBox.information(None, "Erro", "Campo do codigo na layer de COS diferente de STRING (TEXTO). O Campo COS deve ser do tipo TEXTO. A terminar script...")
    iface.mainWindow().resize(QSize(Largura, Altura))
    
elif max(str_value)=='1':
    QMessageBox.information(None, "Erro", "Campo dos codigos na layer COS contem valores alfanumericos ou nulos. O Campo COS, do tipo TEXTO, apenas pode conter digitos. A terminar script...")
    iface.mainWindow().resize(QSize(Largura, Altura))

elif not len(theselections) > 0:
    QMessageBox.information(None, "Erro", "Nenhuma area ardida no interior da area de estudo. A terminar script...")
    iface.mainWindow().resize(QSize(Largura, Altura))
    
else:
    
    # Preparar pastas sequenciais para as 3 fases
    i = 1
    flnm = Pasta_de_destino + "/Perigo"
    while path.exists(flnm) :
        flnm = Pasta_de_destino + "/Perigo" + str(i) 
        i += 1
    os.makedirs(flnm)
    
    # ******************************************************** Calculo da Probabilidade **************************************************************
    progress.setPercentage(15)
    os.makedirs(flnm+"/Probabilidade")
    progress.setText("A preparar dados para calculo da Probabilidade...")
    
    # Criar uma layer em memoria clonada da layer de areas ardidas
    theactivelayer = processing.getObject(Areas_ardidas)
    iface.setActiveLayer(theactivelayer)
    lyrCRS = theactivelayer.crs().authid()
    feats = [feat for feat in theactivelayer.getFeatures()]
    mem_layer1 = QgsVectorLayer("Polygon?crs="+lyr2CRS, "Ars_ards", "memory")
    mem_layer_data = mem_layer1.dataProvider()
    attr = theactivelayer.dataProvider().fields().toList()
    mem_layer_data.addAttributes(attr)
    mem_layer1.updateFields()
    mem_layer_data.addFeatures(feats)

        # Calculo do numero de anos da serie (omega)
    idx = mem_layer1.fieldNameIndex(Campo_ano)
    if mem_layer1.featureCount()<2:
        omega = 1
    else:
        if (mem_layer1.maximumValue(idx) -  mem_layer1.minimumValue(idx)) < 1:
            omega = 1
        else:
            omega = (mem_layer1.maximumValue(idx) -  mem_layer1.minimumValue(idx))

    # Cortar a layer de areas ardidas pela layer da area de estudo

    outputs_SAGAPOLYGONCLIPPING_1=processing.runalg('saga:polygonclipping', lyr1, lyr2,flnm+"/Probabilidade/AAClipped.shp",progress=None)
    mem_layer = QgsVectorLayer(flnm+"/Probabilidade/AAClipped.shp", "Ars_Ards_Clipped", "ogr") 

    # Verificar se mem_layer tem um campo "Id" , "ID" ou "id"; se sim, eliminar este campo
    theFields = []
    for field in mem_layer.fields():
        idx = mem_layer.fieldNameIndex('Id')
        theFields.append(idx)
        idx = mem_layer.fieldNameIndex('ID')
        theFields.append(idx)
        idx = mem_layer.fieldNameIndex('id')
        theFields.append(idx)
        idx = mem_layer.fieldNameIndex('iD')
        theFields.append(idx)
    mem_layer.startEditing()
    mem_layer.deleteAttributes(theFields)
    mem_layer.updateFields()
    mem_layer.commitChanges()

    # Efectuar seccionamento da layer mem-layer e obter novo campo ID com os anos de sobreposicao (recorrencia de incendios)

    progress.setText("Calculando recorrencia de incendios...")
    time.sleep(2)
    
    outputs_SAGAPOLYGONSELFINTERSECTION_1=processing.runalg('saga:polygonselfintersection', mem_layer, Campo_ano, flnm+"/Probabilidade/Autointersect.shp",progress=None)
    auto_intersect =  QgsVectorLayer(flnm+"/Probabilidade/Autointersect.shp", "Autointersect", "ogr") 
    progress.setPercentage(30)
    time.sleep(2)

    processing.runalg('saga:polygonpartstoseparatepolygons', auto_intersect,False,flnm+"/Probabilidade/Recorrencia.shp",progress=None)
    progress.setPercentage(60)
    progress.setText("Calculando frequencia (prob) de ocorrencia de incendios...")
    time.sleep(2)

    # Determinar e escrever num campo os valores de probabilidade
    prob_layer =  QgsVectorLayer(flnm+"/Probabilidade/Recorrencia.shp", "Recorrencia", "ogr") 
    prob_layer.startEditing()
    prob_layer.dataProvider().addAttributes([QgsField("prob",  QVariant.Int)])
    prob_layer.updateFields()

    for feature in prob_layer.getFeatures():
        idx = prob_layer.fieldNameIndex('ID')
        value_count = feature.attributes()[idx].count('|')

        if value_count == 0:
            prob_layer.changeAttributeValue(feature.id(), prob_layer.fieldNameIndex('prob'), 1)
        else:
            prob_layer.changeAttributeValue(feature.id(), prob_layer.fieldNameIndex('prob'), (((value_count+1)*100)/(omega))  )

    prob_layer.updateFields()
    prob_layer.commitChanges()
    progress.setPercentage(75)
    progress.setText("Intersectando layers...")
    time.sleep(2)

    # criar layer da diferenca entre a area_estudo e a prob_layer e colocar esta no campo prob o valor 1
    
    processing.runalg('saga:difference', Area_estudo,prob_layer,True,flnm+"/Probabilidade/Diff.shp",progress=None)
    diff_layer = QgsVectorLayer(flnm+"/Probabilidade/Diff.shp", "Diff", "ogr")  
    diff_layer.startEditing()
    diff_layer.dataProvider().addAttributes([QgsField("prob",  QVariant.Int)])
    diff_layer.updateFields()

    for feature in diff_layer.getFeatures():
        diff_layer.changeAttributeValue(feature.id(), diff_layer.fieldNameIndex('prob'), 1)

    diff_layer.updateFields()
    diff_layer.commitChanges()
    progress.setPercentage(85)
    progress.setText("Calculando mapa final da Probabilidade (shapefile)...")
    time.sleep(1)

    # Fazer o merge das layers da area de estudo nao ardida e da area ardida com recorrencia efectuada
    processing.runalg('saga:mergelayers', [prob_layer,diff_layer],True,True,flnm+"/Probabilidade/ProbabilidadeVector.shp",progress=None)
    progress.setPercentage(90)
    progress.setText("Rasterizando layer vectorial da Probabilidade...")
    time.sleep(1)
    
    # Rasterizar layer ProbabilidadeSHP
    prob_final = QgsVectorLayer(flnm+"/Probabilidade/ProbabilidadeVector.shp", "ProbabilidadeVector", "ogr")     
    xmin = prob_final.extent().xMinimum()
    xmax = prob_final.extent().xMaximum()
    ymin = prob_final.extent().yMinimum()
    ymax = prob_final.extent().yMaximum()

    processing.runalg("gdalogr:rasterize", {"INPUT":prob_final, "FIELD":"prob", "DIMENSIONS":1, 
            "WIDTH": Tamanho_do_pixel, "HEIGHT":Tamanho_do_pixel, "TFW":False, "RTYPE":5, 
            "NO_DATA":-99999, "RAST_EXT":"%f,%f,%f,%f" %(xmin, xmax, ymin, ymax), "BIGTIFF": 2, "OUTPUT":flnm+"/Probabilidade/Probabilidade.tif"},progress=None)
    

    iface.addRasterLayer(flnm+"/Probabilidade/Probabilidade.tif", "Probabilidade")
    progress.setPercentage(100)

    # ******************************************************** Calculo da Susceptibilidade **************************************************************
    progress.setText("A preparar dados para calculo da Susceptibilidade...")
    os.makedirs(flnm+'/Susceptibilidade')
    progress.setPercentage(15)
    time.sleep(2)

    # Calcular raster de declives a partir do MDT e reclassificar este raster de declives segundo as classes do Guia Tecnico
    outputs_GDALOGRSLOPE_1=processing.runalg('gdalogr:slope', MDT,1.0,True,False,False,1.0,None, progress=None)
    
    outputs_SAGACLIPGRIDWITHPOLYGON_1=processing.runalg('saga:clipgridwithpolygon', outputs_GDALOGRSLOPE_1['OUTPUT'],Area_estudo,0,flnm+'/Susceptibilidade/Declives.tif', progress=None)
    
    outputs_SAGARECLASSIFYGRIDVALUES_1=processing.runalg('saga:reclassifygridvalues', outputs_SAGACLIPGRIDWITHPOLYGON_1['OUTPUT'],2,0.0,1.0,0,0.0,1.0,2.0,0,'0,5,2,5,10,3,10,15,4,15,20,5,20,75,6',0,True,-99999.0,False,0.0,flnm+'/Susceptibilidade/DeclivesReclass.tif', progress=None)
    
    progress.setPercentage(30)
    progress.setText("Calculando declives...")
    time.sleep(2)
    # Clipar a COS com a area de estudo e apanhar a extent desta clipagem   
    outputs_QGISCLIP_1=processing.runalg('qgis:clip', COS,Area_estudo,None,progress=None)
    
    # Selecionar as features com codigo sugerido pelo Guia Tecnico, inverter e eliminar features com restantes codigos
    COSclipped = processing.getObject(outputs_QGISCLIP_1['OUTPUT'])
    fields = COSclipped.pendingFields()
    attrs_name={1:'212', 2:'213', 3:'221', 4:'222', 5:'241', 6:'331', 7:'211', 8:'223', 9:'231', 10:'242', 11:'244', 12:'243', 13:'311', 14:'312', 15:'313', 16:'321', 17:'322', 18:'323', 19:'324', 20:'332', 21:'333', 22:'334'}
    sel=[]
    for key, value in attrs_name.items():
        for feature in COSclipped.getFeatures():
            idx = COSclipped.fieldNameIndex(Campo_COS)
            if str((feature.attributes()[idx]))==value:
                sel.append(feature.id())
     
    COSclipped.setSelectedFeatures(sel)
    COSclipped.invertSelection()

    selfeatures = COSclipped.selectedFeatures()
    COSclipped.startEditing()
    for f in selfeatures:
        COSclipped.deleteFeature(f.id())
    COSclipped.updateFields()
    COSclipped.commitChanges()
    progress.setPercentage(60)
    progress.setText("Preparando e rasterizando COS...")
    time.sleep(2)
    
    # Rasterizar o COSclipped
    COSclipped = processing.getObject(outputs_QGISCLIP_1['OUTPUT'])
    xmin = COSclipped.extent().xMinimum()
    xmax = COSclipped.extent().xMaximum()
    ymin = COSclipped.extent().yMinimum()
    ymax = COSclipped.extent().yMaximum()
    
    susraster=processing.runalg("gdalogr:rasterize", {"INPUT":COSclipped, "FIELD":Campo_COS, "DIMENSIONS":1, 
            "WIDTH": 10, "HEIGHT":10, "TFW":False, "RTYPE":5, 
            "NO_DATA":-99999, "RAST_EXT":"%f,%f,%f,%f" %(xmin, xmax, ymin, ymax), "BIGTIFF": 2, "OUTPUT": flnm+'/Susceptibilidade/COS_raster.tif'},progress=None)

    progress.setPercentage(85)
    progress.setText("Criando raster da Susceptibilidade...")
    time.sleep(2)
    
    outputs_SAGACHANGEGRIDVALUES_1=processing.runalg('saga:changegridvalues', flnm+'/Susceptibilidade/COS_raster.tif',0,'212,0,2,213,0,2,221,0,2,222,0,2,241,0,2,331,0,2,211,0,3,223,0,3,231,0,3,242,0,3,244,0,3,243,0,4,311,0,4,312,0,4,313,0,4,321,0,4,322,0,4,323,0,4,324,0,4,332,0,4,333,0,4,334,0,4',0,flnm+'/Susceptibilidade/COS_reclass.tif',progress=None)
    
    outputs_SAGARASTERCALCULATOR_1=processing.runalg('saga:rastercalculator', flnm+'/Susceptibilidade/COS_reclass.tif',[outputs_SAGARECLASSIFYGRIDVALUES_1['RESULT']],'a*b',0,False,8,flnm+'/Susceptibilidade/Susceptibilidade.tif', progress=None)
    
    iface.addRasterLayer(flnm+'/Susceptibilidade/Susceptibilidade.tif', "Susceptibilidade")
    progress.setPercentage(100)
    time.sleep(2)

    # ******************************************************** Calculo da Perigosidade **************************************************************
    progress.setText("A preparar dados para calculo da Perigosidade...")
    progress.setPercentage(25)
    os.makedirs(flnm+'/Perigosidade')

    # Calcular o raster de Perigosidade antes de quantilizado, pelo produto dos rasters da Probabilidade e Susceptibilidade
    progress.setPercentage(50)
    progress.setText("A calcular raster da PerigosidadeNQ...")

    outputs_SAGARASTERCALCULATOR_1=processing.runalg('saga:rastercalculator', "Probabilidade", "Susceptibilidade",'a*b',0,False,8,flnm+'/Perigosidade/PerigosidadeNQ.tif', progress=None)
    iface.addRasterLayer(flnm+'/Perigosidade/PerigosidadeNQ.tif', "PerigosidadeNQ")
    progress.setText("A iniciar calculo de quantis...")
    progress.setPercentage(60)
    outputs_SAGASIMPLEFILTER_1=processing.runalg('saga:simplefilter', outputs_SAGARASTERCALCULATOR_1['RESULT'], 0,0,3,3,None, progress=None)
    progress.setPercentage(70)
    outputs_SAGASIMPLEFILTER_2=processing.runalg('saga:simplefilter', outputs_SAGASIMPLEFILTER_1["RESULT"], 0,0,3,3,None, progress=None)
    progress.setPercentage(80)
    outputs_SAGASIMPLEFILTER_3=processing.runalg('saga:simplefilter', outputs_SAGASIMPLEFILTER_2["RESULT"], 0,0,3,3,None, progress=None)
    progress.setPercentage(90)
    outputs_SAGASIMPLEFILTER_4=processing.runalg('saga:simplefilter', outputs_SAGASIMPLEFILTER_3["RESULT"], 0,0,3,3, None,  progress=None)
    
    out = outputs_SAGASIMPLEFILTER_4["RESULT"]
    progress.setPercentage(100)
    time.sleep(2)
    theActiveLayer = QgsRasterLayer(out)
    fileName = theActiveLayer.source()
    dataset = gdal.Open(str(fileName))
    band = dataset.GetRasterBand(1)
    nodata = band.GetNoDataValue()
    array = dataset.ReadAsArray()
    # Exxluir pixels NODATA do processo de quantilizacao
    new_array = array
    i = 0
    count=len(new_array)
    nan_array = array
    nan_array[array == nodata] = np.nan
    # Preparar os percentis
    progress.setText("A calcular percentis...")
    percentile_80 = np.nanpercentile(nan_array, 80)
    percentile_60 = np.nanpercentile(nan_array, 60)
    percentile_40 = np.nanpercentile(nan_array, 40)
    percentile_20 = np.nanpercentile(nan_array, 20)
    percentile_0 = np.nanpercentile(nan_array, 0)
    # Separar os pixels por percentis
    for i, v in enumerate(new_array):
        percent = (i/float(count)) * 100
        progress.setPercentage(percent)
        for j, element in enumerate(v):
            if element <= percentile_0:
                new_array[i,j] = 1
            if element > percentile_0 and element <= percentile_20:
                new_array[i,j] = 2
            if element > percentile_20 and element <= percentile_40:
                new_array[i,j] = 3
            if element > percentile_40 and element <= percentile_60:
                new_array[i,j] = 4
            if element > percentile_60 and element <= percentile_80:
                new_array[i,j] = 5
            if element > percentile_80:
                new_array[i,j] = 6
    new_array[ new_array != new_array ] = nodata
    # Preparar raster de saida com mesmo EPSG
    geotransform = dataset.GetGeoTransform()
    wkt = dataset.GetProjection()
    # Criar raster intermedio do tipo TIFF 
    driver = gdal.GetDriverByName("GTiff")
    output_file = (str(flnm)+"/Perigosidade/Raster_intermedio.tif")
    dst_ds = driver.Create(output_file, band.XSize, band.YSize, 1, gdal.GDT_Int16)
    dst_ds.GetRasterBand(1).WriteArray( new_array )
    dst_ds.GetRasterBand(1).SetNoDataValue(nodata)
    dst_ds.SetGeoTransform(geotransform)
    srs = osr.SpatialReference()
    srs.ImportFromWkt(wkt)
    dst_ds.SetProjection( srs.ExportToWkt() )
    dataset = None
    dst_ds = None
    # Colocar os valores inferiores a zero como NODATA e colocar raster final na TOC
    progress.setText("A preparar raster de saida...")
    outputs_SAGARASTERCALCULATOR_1=processing.runalg('saga:rastercalculator', output_file,[],'ifelse(a=0, 0/0, ifelse(a<0, 0/0, a))',3,False,7,None, progress=None)
    progress.setText("A reclassificar raster de saida...")
    processing.runalg('saga:changegridvalues', outputs_SAGARASTERCALCULATOR_1['RESULT'],2,'1,2,1,2,3,2,3,4,3,4,5,4,5,6,5',3,flnm+'/Perigosidade/Perigosidade.tif', progress=None)
    
    # Construir legenda
    progress.setText("A construir legenda do raster de saida...")
    lyr = QgsRasterLayer(flnm+'/Perigosidade/Perigosidade.tif', "Perigosidade")
    s = QgsRasterShader()
    c = QgsColorRampShader()
    c.setColorRampType(QgsColorRampShader.INTERPOLATED)
    i = [] 

    i.append(QgsColorRampShader.ColorRampItem(1, QColor(26,150,65), 'Muito Baixa'))
    i.append(QgsColorRampShader.ColorRampItem(2, QColor(166,217,106), 'Baixa'))
    i.append(QgsColorRampShader.ColorRampItem(3, QColor(255,255,92), 'Media'))
    i.append(QgsColorRampShader.ColorRampItem(4, QColor(253,174,97), 'Alta'))
    i.append(QgsColorRampShader.ColorRampItem(5, QColor(215,25,28), 'Muito Alta'))

    c.setColorRampItemList(i)
    s.setRasterShaderFunction(c)
    ps = QgsSingleBandPseudoColorRenderer(lyr.dataProvider(), 1, s)
    lyr.setRenderer(ps)
    QgsMapLayerRegistry.instance().addMapLayer(lyr)
    progress.setPercentage(100)
    time.sleep(2)
    QMessageBox.information(None, "Nota", "Script executado!")    
    iface.mainWindow().resize(QSize(Largura, Altura))


# Sobral Almeida, Agosto/2020